<?php

/**
 * This is the model class for table "htmlblock".
 *
 * The followings are the available columns in table 'htmlblock':
 * @property integer $id
 * @property string $title
 * @property string $content
 * @property string $content_en
 * @property string $language
 * @property integer $create_datetime
 * @property integer $update_datetime
 * @property string $slug
 */
class Htmlblock extends FlexActiveRecord {

    /**
     * @return string the associated database table name
     */
    public function tableName() {
        return 'htmlblock';
    }

    protected function beforeSave() {
        if (strlen($this->slug) == 0) {
            $this->slug = Common::sanitize($this->title);
        }
        return parent::beforeSave();
    }

    public function beforeValidate() {
        if ($this->isNewRecord) {
            // set the create date, last updated date and the user doing the creating  
            $this->create_datetime = time();
            $this->update_datetime = time();
        } else {
            //not a new record, so just set the last updated time and last updated user id     
            $this->update_datetime = time();
        }
        return parent::beforeValidate();
    }

    /**
     * @return array validation rules for model attributes.
     */
    public function rules() {
        // NOTE: you should only define rules for those attributes that
        // will receive user inputs.
        return array(
            array('title, content, language, create_datetime, update_datetime, slug', 'required'),
            array('create_datetime, update_datetime', 'numerical', 'integerOnly' => true),
            array('title', 'length', 'max' => 200),
            array('language', 'length', 'max' => 2),
            array('slug', 'length', 'max' => 100),
            array('content_en', 'safe'),
            // The following rule is used by search().
            // @todo Please remove those attributes that should not be searched.
            array('id, title, content,content_en, language, create_datetime, update_datetime, slug', 'safe', 'on' => 'search'),
        );
    }

    /**
     * @return array relational rules.
     */
    public function relations() {
        // NOTE: you may need to adjust the relation name and the related
        // class name for the relations automatically generated below.
        return array(
        );
    }

    /**
     * @return array customized attribute labels (name=>label)
     */
    public function attributeLabels() {
        return array(
            'id' => Yii::t('admin', 'ID'),
            'title' => Yii::t('admin', 'Title'),
            'content' => Yii::t('admin', 'Content'),
            'content_en' => Yii::t('admin','Content En'),
            'language' => Yii::t('admin', 'Language'),
            'create_datetime' => Yii::t('admin', 'Create Datetime'),
            'update_datetime' => Yii::t('admin', 'Update Datetime'),
            'slug' => Yii::t('admin', 'Slug'),
        );
    }

    /**
     * Retrieves a list of models based on the current search/filter conditions.
     *
     * Typical usecase:
     * - Initialize the model fields with values from filter form.
     * - Execute this method to get CActiveDataProvider instance which will filter
     * models according to data in model fields.
     * - Pass data provider to CGridView, CListView or any similar widget.
     *
     * @return CActiveDataProvider the data provider that can return the models
     * based on the search/filter conditions.
     */
    public function search() {
        // @todo Please modify the following code to remove attributes that should not be searched.

        $criteria = new CDbCriteria;

        $criteria->compare('id', $this->id);
        $criteria->compare('title', $this->title, true);
        $criteria->compare('content', $this->content, true);
        $criteria->compare('content_en',$this->content_en,true);
        $criteria->compare('language', $this->language, true);
        $criteria->compare('create_datetime', $this->create_datetime);
        $criteria->compare('update_datetime', $this->update_datetime);
        $criteria->compare('slug', $this->slug, true);

        return new CActiveDataProvider($this, array(
            'criteria' => $criteria,
        ));
    }

    public function scopes() {
        return array(
            'filterLanguage' => array(
                'condition' => "t.language='" . Yii::app()->language . "'",
            ),
        );
    }

    /**
     * Returns the static model of the specified AR class.
     * Please note that you should have this exact method in all your CActiveRecord descendants!
     * @param string $className active record class name.
     * @return Htmlblock the static model class
     */
    public static function model($className = __CLASS__) {
        return parent::model($className);
    }

}
